<?php
// todo 'usar o service'
namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Request;

class Tco01000CardapioBase extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $crudService;
    protected $environment;
    protected $cardapiobaseService;
    protected $tcoUtil;
    protected $newCode; 
    protected $entityManager; 

    public function __construct($crudService, $parameterBag, $environment, $cardapiobaseService, $tcoUtil, $newCode, $entityManager) {
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->cardapiobaseService = $cardapiobaseService;
        $this->tcoUtil = $tcoUtil;
        $this->newCode = $newCode;
        $this->entityManager = $entityManager;
    }
    
    protected $DEL_ITPARTSEGCARDBASE = "DELETE FROM ITPARTSEGCARDBASE 
                                         WHERE NRPARTSEGCARDBASE IN ( SELECT NRPARTSEGCARDBASE
                                                                        FROM PARTSEGCARDBASE
                                                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                         AND NRORG = :NRORG )"; 
    protected $DEL_PARTSEGCARDBASE = "DELETE FROM PARTSEGCARDBASE 
                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                         AND NRORG = :NRORG"; 
    protected $DEL_AMOSTRACARDBASE = "DELETE FROM AMOSTRACARDBASE
                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                         AND NRORG = :NRORG"; 
    protected $DEL_LIMPEZACARDBASE = "DELETE FROM LIMPEZACARDBASE
                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                         AND NRORG = :NRORG"; 
    protected $DEL_DESCARTCARDBASE = "DELETE FROM DESCARTCARDBASE
                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                         AND NRORG = :NRORG"; 
    protected $DEL_ITEMADESAOCBASE = "DELETE FROM ITEMADESAOCBASE
                                       WHERE NRADESAOCARDBASE IN ( SELECT NRADESAOCARDBASE 
                                                                     FROM ADESAOCARDBASE
                                                                    WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                      AND NRORG = :NRORG )"; 
    protected $DEL_ATIVCLIADESAOCBASE = "DELETE FROM ATIVCLIADESAOCBASE
                                          WHERE NRADESAOCARDBASE IN ( SELECT NRADESAOCARDBASE 
                                                                        FROM ADESAOCARDBASE
                                                                       WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                         AND NRORG = :NRORG )"; 
    protected $DEL_SEGMERADESAOCBASE = "DELETE FROM SEGMERADESAOCBASE
                                         WHERE NRADESAOCARDBASE IN ( SELECT NRADESAOCARDBASE 
                                                                       FROM ADESAOCARDBASE
                                                                      WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                        AND NRORG = :NRORG )"; 
    protected $DEL_ADESAOCARDBASE = "DELETE FROM ADESAOCARDBASE
                                      WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                        AND NRORG = :NRORG"; 
    protected $DEL_ITEMGRAMCARDBASE = "DELETE FROM ITEMGRAMCARDBASE
                                        WHERE NRGRAMATURACARDBASE IN ( SELECT NRGRAMATURACARDBASE
                                                                         FROM GRAMATURACARDBASE
                                                                        WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                          AND NRORG = :NRORG )"; 
    protected $DEL_GRAMATURACARDBASE = "DELETE FROM GRAMATURACARDBASE
                                         WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                           AND NRORG = :NRORG"; 
    protected $DEL_CNFCCOMPLCARDBASE = "DELETE FROM CNFCCOMPLCARDBASE
                                         WHERE NRCARDCOMPLCARDBASE IN ( SELECT NRCARDCOMPLCARDBASE
                                                                          FROM CARDCOMPLCARDBASE
                                                                         WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                                                           AND NRORG = :NRORG )"; 
    protected $DEL_CARDCOMPLCARDBASE = "DELETE FROM CARDCOMPLCARDBASE
                                         WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE
                                           AND NRORG = :NRORG"; 
    protected $DEL_REGIAOPRATCARDBASE = "DELETE FROM REGIAOPRATCARDBASE
                                          WHERE NRPRATCOMPCARDBASE IN ( SELECT PRATCOMPCARDBASE.NRPRATCOMPCARDBASE
                                                                          FROM PRATCOMPCARDBASE
                                                                         INNER JOIN COMPCARDBASE
                                                                            ON COMPCARDBASE.NRCOMPCARDBASE = PRATCOMPCARDBASE.NRCOMPCARDBASE 
                                                                         WHERE COMPCARDBASE.NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                                                           AND PRATCOMPCARDBASE.NRORG = :NRORG )"; 
    protected $DEL_PRATCOMPCARDBASE = "DELETE FROM PRATCOMPCARDBASE
                                        WHERE NRCOMPCARDBASE IN ( SELECT NRCOMPCARDBASE
                                                                    FROM COMPCARDBASE
                                                                   WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                                                     AND NRORG = :NRORG )"; 
    protected $DEL_COMPCARDBASE = "DELETE FROM COMPCARDBASE
                                    WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                      AND NRORG = :NRORG"; 
    protected $DEL_SEGMERCARDBASE = "DELETE FROM SEGMERCARDBASE
                                      WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                        AND NRORG = :NRORG"; 
    protected $DEL_DIACARDBASE = "DELETE FROM DIACARDBASE
                                   WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                     AND NRORG = :NRORG"; 
    protected $DEL_CONFIGCARDBASE = "DELETE FROM CONFIGCARDBASE
                                      WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                        AND NRORG = :NRORG"; 
    protected $DEL_CARDAPIOBASE = "DELETE FROM CARDAPIOBASE
                                    WHERE NRCARDAPIOBASE = :NRCARDAPIOBASE 
                                      AND NRORG = :NRORG";

    public function salvaNovoCardapioBase(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $cardapioBaseExistente = $this->cardapiobaseService->retornaCardapioBaseExistente($row);
        if(empty($cardapioBaseExistente)){
            if($this->isValid($row, $response)){
                // $this->cardapiobaseService->defineNovoCodigoCardapioBase($row);
                    
                $this->salvaCardapioBase($request);
                $columnsToReturn = $this->crudService->getColumnsToReturn();
                
                if($row["CDCARDCOMPLCARDBASE"] !== "" && isset($row["CDCARDCOMPLCARDBASE"]) && sizeof($row["CDCARDCOMPLCARDBASE"]) > 0){
                   $this->salvaCardapioComplementarCardapioBase($row, $columnsToReturn);
                }
                if(isset($row["DSSEGMER"]) && sizeof($row["DSSEGMER"]) > 0){
                    $this->salvaSegmentosCardapioBase($row, $columnsToReturn);
                }
                
                $this->salvaDiacardbase($columnsToReturn);
                
                $response->addDataSet(new DataSet("cardapioBase", array()));
                $response->addDataSet(new DataSet("columnsToReturn", $columnsToReturn));
            }
        } else {
            $response->addDataSet(new DataSet("cardapioBase", $cardapioBaseExistente));
        }
    }
    
    private function isValid($row, $response) {
        
        if(!isset($row["NRSERVICOPROPOSTA"])){
            $response->addMessage(new Message('SERVICOPROPOSTA_NAO_PREENCHIDO'));
            return false;
        }
        if(!(sizeof($row["DSSEGMER"]) > 0)){
            $response->addMessage(new Message('SEGMENTO_MERCADO_NAO_PREENCHIDO'));
            return false;
        }
        if(!isset($row["NRPADRAOQUALIDADE"])){
            $response->addMessage(new Message('PADRAO_QUALIDADE_NAO_PREENCHIDO'));
            return false;
        }
        if(!isset($row["PERIODO"]["start"]) && !isset($row["PERIODO"]["end"])){
            $response->addMessage(new Message('PERIODO_INVALIDO'));
            return false;
        }
        
        $dataini = str_replace('/', '-', $row["PERIODO"]["start"]);
        $datafim = str_replace('/', '-', $row["PERIODO"]["end"]);
        
        if(strtotime($dataini) > strtotime($datafim)){
            $response->addMessage(new Message('PERIODO_INVALIDO'));
            return false;
        }
        
        return true;
    }
    
    private function salvaCardapioBase($request) {
        $row = $request->getRow();
        if($row["CDCARDCOMPLCARDBASE"] !== "" && isset($row["CDCARDCOMPLCARDBASE"]) && sizeof($row["CDCARDCOMPLCARDBASE"]) > 0){
            $row["IDCOMPLEMENTAR"] = 'S';
        }else{
            $row["IDCOMPLEMENTAR"] = 'N';
        }
        
        $rows = $this->crudService->getRowsToSave($request, "cardapiobase");
        $rows[0]["CDCARDAPIOBASE"] = str_pad($rows[0]["NRCARDAPIOBASE"], 10, "0", STR_PAD_LEFT);
        $this->crudService->save("cardapiobase", $rows);
        $rows[0]["__is_new"] = false;
        $this->crudService->addColumnToReturn($rows[0]);
    }
    
    private function salvaSegmentosCardapioBase($row, $columnsToReturn) {
        $rowsToSave = $this->buildRowsToSaveSegmentosCardapioBase($row, $columnsToReturn);
        $this->salvaNovosSegmentosCardapioBase($rowsToSave);
    }
    
    private function salvaNovosSegmentosCardapioBase($rowsToSave) {
        $dataSet = new DataSet("segmercardbase", $rowsToSave);
        $request = new DTO\Request\DataSet($dataSet, "", "", "");
        $rows = $this->crudService->getRowsToSave($request, "segmercardbase");
        $this->crudService->save("segmercardbase", $rows);
    }
    
    private function buildRowsToSaveSegmentosCardapioBase($row, $columnsToReturn){
        $rows = array();
        foreach ($row["DSSEGMER"] as $segmento) {
            array_push($rows, array(
                "NRCARDAPIOBASE"    => $columnsToReturn[0]["NRCARDAPIOBASE"],
                "CDSEGMER"          => $segmento, 
                "__using_unit"      => false, 
                "__new_code_pk"     => "SEGMERCARDBASE", 
                "__table_pk"        => "NRSEGMERCARDBASE", 
                "__new_code_length" => 1, 
                "__cast_number"     => false, 
                "__is_new"          => true
            ));
        }
        
        return $rows;
    }
    
    private function salvaCardapioComplementarCardapioBase($row, $columnsToReturn) {
        $rowsToSave = $this->buildRowsToSaveCardapioComplementarCardapioBase($row, $columnsToReturn);
        $this->salvaNovosCardapioComplementarCardapioBase($rowsToSave);
    }
    
    private function salvaNovosCardapioComplementarCardapioBase($rowsToSave) {
        $dataSet = new DataSet("cardcomplcardbase", $rowsToSave);
        $request = new DTO\Request\DataSet($dataSet, "", "", "");
        $rows = $this->crudService->getRowsToSave($request, "cardcomplcardbase");
        $this->crudService->save("cardcomplcardbase", $rows);
    }
    
    private function buildRowsToSaveCardapioComplementarCardapioBase($row, $columnsToReturn) {
        $rows = array();
        foreach ($row["CDCARDCOMPLCARDBASE"] as $cardapio) {
            array_push($rows, array(
                "NRCARDAPIOBASE"      => $columnsToReturn[0]["NRCARDAPIOBASE"],
                "NRCARDAPIOBASECOMPL" => $cardapio, 
                "__using_unit"        => false, 
                "__new_code_pk"       => "CARDCOMPLCARDBASE", 
                "__table_pk"          => "NRCARDCOMPLCARDBASE", 
                "__new_code_length"   => 1, 
                "__cast_number"       => false, 
                "__is_new"            => true
            ));
        }
        
        return $rows;
    }
    
    public function verificaComposicaoCardapioBaseExistente(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $response->addDataSet(new DataSet("compCardapioBaseExistente", $this->cardapiobaseService->findComposicaoCardapioBase($row)));
    }
    
    private function salvaDiacardbase($columnsToReturn){
        $qtDiasCardBase = intval($columnsToReturn[0]["QTDDIASCARDBASE"]);
        $rowsToSave = $this->buildRowsToSaveDiasCardapioBase($columnsToReturn, $qtDiasCardBase, 7);
        $dataSet = new DataSet("diacardbase", $rowsToSave);
        $request = new DTO\Request\DataSet($dataSet, "", "", "");
        $rows = $this->crudService->getRowsToSave($request, "diacardbase");
        $this->crudService->save("diacardbase", $rows);
    }
    
    private function buildRowsToSaveDiasCardapioBase($row, $totalDays, $daysPerWeek) {
        $semana = 0;
        $rows = array();
        
        for ($i = 1; $i <= $totalDays; $i++) {
            if($i%$daysPerWeek === 1) {
                $semana++;
            }
            array_push($rows, array(
                "NRCARDAPIOBASE"    => $row[0]["NRCARDAPIOBASE"],
                "NRDIASEMANA"       => $i%$daysPerWeek === 0 ? $daysPerWeek : $i%$daysPerWeek,
                "NRSEMANA"          => $semana, 
                "__using_unit"      => false, 
                "__new_code_pk"     => "DIACARDBASE", 
                "__table_pk"        => "NRDIACARDBASE", 
                "__new_code_length" => 1, 
                "__cast_number"     => false, 
                "__is_new"          => true
            ));
        }
        return $rows;
    }
    
    public function addOrUpdatePratoTrab($request, $response){
        try {
            $this->dataSourceName = 'compcardtrab';
            $row = $request->getDataSet()->getRows()[0];
            if(empty($row["NRCOMPCARDTRAB"])){
                $row["NRCOMPCARDTRAB"] = $this->newCode->getCodeByTableName('COMPCARDTRAB', $this->environment->getNrOrgTrab());
            }
            $row["__is_new"] = $this->tcoUtil->verifyCompCardTrabIsNew($row);
            $this->saveReceCardTrab($row);
            $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
            $this->crudService->save($this->dataSourceName, $rows);            
            $this->cardapiobaseService->procedureTrocaPrato($row);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    private function saveReceCardTrab($row){
        foreach($row['PRODUTOS'] as $key => &$product){
            
            if(empty($product["NRRECEPRATCARDTRAB"])){
                $product["NRRECEPRATCARDTRAB"] = $this->newCode->getCodeByTableName('RECEPRATCARDTRAB', $this->environment->getNrOrgTrab());
            }
            $rowProduct = $this->buildParamsProducts($row, $product);
            $rowProduct[0]["__is_new"] = $this->cardapiobaseService->verifyReceCardTrabIsNew($rowProduct[0]);
            $dataSet = new DataSet("recepratcardtrab", $rowProduct);
            $request = new DTO\Request\DataSet($dataSet, "", "", "");
            $rowProduct = $this->crudService->getRowsToSave($request, 'recepratcardtrab');
            $this->crudService->save('recepratcardtrab', $rowProduct); 
        }
    }
    
    private function buildParamsProducts($row, $product){
        return array(
            array(
                "NRRECEPRATCARDTRAB" => $product["NRRECEPRATCARDTRAB"], 
                "NRCARDAPIOTRAB" => $row["NRCARDAPIOTRAB"], 
                "CDFILAUXPRAT" => $product["CDFILAUXPRAT"], 
                "CDPRATO" => $row["CDPRATO"], 
                "CDPRODUTO" => $product["CDPRODUTO"], 
                "QTPRODRECCARDTRAB" => $product["QTPRODUTO"], 
                "VRPEFATCOCCARDTRAB" => $product["VRAPCOCCAO"], 
                "VRPEFATCORCARDTRAB" => $product["VRAPLIMPEZA"], 
                "SGUNIDADE" => $product["SGUNIDADE"],
                "QTBRUTACARDTRABUNR" => $product["QTDBRUTA"],
                "IDPRODBASECARDTRAB" => $product["BASE"],
                "NRORG" => $this->environment->getNrOrg(),
                "IDQTDEFIXCARDTRAB" => $product["QTFIX"]
            )
        );
    }
    
    public function removeCardapioBase(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $cardapioBaseEmUso = $this->cardapiobaseService->retornaOcorrenciaCardapioBase($row);
        
        $declaracoesDelete = array(
            "ITPARTSEGCARDBASE" => $this->DEL_ITPARTSEGCARDBASE,
            "PARTSEGCARDBASE" => $this->DEL_PARTSEGCARDBASE,
            "AMOSTRACARDBASE" => $this->DEL_AMOSTRACARDBASE,
            "LIMPEZACARDBASE" => $this->DEL_LIMPEZACARDBASE,
            "DESCARTCARDBASE" => $this->DEL_DESCARTCARDBASE,
            "ITEMADESAOCBASE" => $this->DEL_ITEMADESAOCBASE,
            "ATIVCLIADESAOCBASE" => $this->DEL_ATIVCLIADESAOCBASE,
            "SEGMERADESAOCBASE" => $this->DEL_SEGMERADESAOCBASE,
            "ADESAOCARDBASE" => $this->DEL_ADESAOCARDBASE,
            "ITEMGRAMCARDBASE" => $this->DEL_ITEMGRAMCARDBASE,
            "GRAMATURACARDBASE" => $this->DEL_GRAMATURACARDBASE,
            "CNFCCOMPLCARDBASE" => $this->DEL_CNFCCOMPLCARDBASE,
            "CARDCOMPLCARDBASE" => $this->DEL_CARDCOMPLCARDBASE,
            "REGIAOPRATCARDBASE" => $this->DEL_REGIAOPRATCARDBASE,
            "PRATCOMPCARDBASE" => $this->DEL_PRATCOMPCARDBASE,
            "COMPCARDBASE" => $this->DEL_COMPCARDBASE,
            "SEGMERCARDBASE" => $this->DEL_SEGMERCARDBASE,
            "DIACARDBASE" => $this->DEL_DIACARDBASE,
            "CONFIGCARDBASE" => $this->DEL_CONFIGCARDBASE,
            "CARDAPIOBASE" => $this->DEL_CARDAPIOBASE
        );
        
        if(empty($cardapioBaseEmUso)){
            $connection = $this->entityManager->getConnection();
            
            try {
                $this->entityManager->beginTransaction();
            
                foreach($declaracoesDelete as $tabela => $declaracao) {
                    $params = array(
                        "NRCARDAPIOBASE" => $row["NRCARDAPIOBASE"],
                        "NRORG" => $this->environment->getNrOrgTrab()
                    );
                    
                    $sql = $connection->prepare($declaracao);
                    $sql->execute($params);
                }
                
                $this->entityManager->commit();
            } catch(\Exception $e){
                $this->entityManager->rollback();
                $response->setError(new DTO\Response\Error($e->getMessage(), 500, $e->getTraceAsString()));
    	    }
    	    
            $response->addDataSet(new DataSet("cardapioBaseEmUso", array()));
        } else {
            $response->addDataSet(new DataSet("cardapioBaseEmUso", $cardapioBaseEmUso));
        }
        
    }
}
